Subject: Re: [PATCH] powerpc/atomic: Use YZ constraints for DS-form instructions

From: Michael Ellerman <[email-masked]>
Date: Thu, 19 Sep 2024 22:43:10 +1000

Segher Boessenkool <[email-masked]> writes:
> Hi!
>
> On Mon, Sep 16, 2024 at 10:05:10PM +1000, Michael Ellerman wrote:
>> The 'ld' and 'std' instructions require a 4-byte aligned displacement
>> because they are DS-form instructions. But the "m" asm constraint
>> doesn't enforce that.
>> 
>> That can lead to build errors if the compiler chooses a non-aligned
>> displacement, as seen with GCC 14:
>> 
>>   /tmp/ccuSzwiR.s: Assembler messages:
>>   /tmp/ccuSzwiR.s:2579: Error: operand out of domain (39 is not a multiple of 4)
>>   make[5]: *** [scripts/Makefile.build:229: net/core/page_pool.o] Error 1
>> 
>> Dumping the generated assembler shows:
>> 
>>   ld 8,39(8)       # MEM[(const struct atomic64_t *)_29].counter, t
>> 
>> Use the YZ constraints to tell the compiler either to generate a DS-form
>> displacement, or use an X-form instruction, either of which prevents the
>> build error.
>
> Great explanation text, a perfect commit!  :-)

Thanks - I'm sure there's something that could be better, but I do try :)

cheers